VERSION 5.00
Begin VB.Form frmCheckPhone 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Check Phone Number"
   ClientHeight    =   2640
   ClientLeft      =   4815
   ClientTop       =   3585
   ClientWidth     =   5670
   Icon            =   "PhCheck.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2640
   ScaleWidth      =   5670
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.CheckBox chkShowAgain 
      Caption         =   "S&how this again when phone number is incomplete or unclear"
      Height          =   285
      Left            =   150
      TabIndex        =   3
      Top             =   2220
      Width           =   5385
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   375
      Left            =   4410
      TabIndex        =   5
      Top             =   690
      Width           =   1125
   End
   Begin VB.CommandButton cmdOk 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   375
      Left            =   4410
      TabIndex        =   4
      Top             =   210
      Width           =   1125
   End
   Begin VB.Frame fmePhoneDetails 
      Caption         =   "Phone details"
      Height          =   1995
      Left            =   120
      TabIndex        =   6
      Top             =   120
      Width           =   4155
      Begin VB.TextBox txtLocalNumber 
         Height          =   315
         Left            =   1500
         TabIndex        =   2
         Top             =   1530
         Width           =   2535
      End
      Begin VB.TextBox txtCityAreaCode 
         Height          =   315
         Left            =   1500
         TabIndex        =   1
         Top             =   1140
         Width           =   2535
      End
      Begin VB.ComboBox cboCountryRegion 
         Height          =   315
         Left            =   1500
         Style           =   2  'Dropdown List
         TabIndex        =   0
         Top             =   720
         Width           =   2535
      End
      Begin VB.Label lblLocalNumber 
         Caption         =   "&Local number:"
         Height          =   225
         Left            =   180
         TabIndex        =   10
         Top             =   1590
         Width           =   1185
      End
      Begin VB.Label lblCityAreaCode 
         Caption         =   "City/&Area code:"
         Height          =   195
         Left            =   180
         TabIndex        =   9
         Top             =   1200
         Width           =   1185
      End
      Begin VB.Label lblCountryRegion 
         Caption         =   "&Country/Region:"
         Height          =   195
         Left            =   180
         TabIndex        =   8
         Top             =   780
         Width           =   1185
      End
      Begin VB.Label lblCompletePhone 
         BorderStyle     =   1  'Fixed Single
         Height          =   315
         Left            =   150
         TabIndex        =   7
         Top             =   330
         Width           =   3855
      End
   End
End
Attribute VB_Name = "frmCheckPhone"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_objPhoneNumber    As PhoneNumber
Private m_strCountryList    As String
Private m_blnShowAgain      As Boolean
Private m_blnApplyChanges   As Boolean
Private m_blnLocked         As Boolean

Public Property Get PhoneNumber() As PhoneNumber

    Set PhoneNumber = m_objPhoneNumber

End Property

Public Property Get ApplyChanges() As Boolean

    ApplyChanges = m_blnApplyChanges

End Property

Private Property Let ApplyChanges _
                        ( _
                        ByVal RHS As Boolean _
                        )

    m_blnApplyChanges = RHS

End Property

Private Sub cboCountryRegion_Click()

    With cboCountryRegion
        If .ListIndex = -1 Then
            PhoneNumber.CountryCode = vbNullString
        Else
            PhoneNumber.CountryCode = .ItemData(.ListIndex)
        End If
    End With
    
    lblCompletePhone.Caption = PhoneNumber.Serialize

End Sub

Private Sub chkShowAgain_Click()

    ShowAgain = (chkShowAgain.Value = vbChecked)

End Sub

Private Sub cmdCancel_Click()
    
    Unload Me
    
End Sub

Private Sub cmdOk_Click()
            
    ApplyChanges = True
    Unload Me
    
End Sub

Public Property Let CountryList _
                        ( _
                        ByVal RHS As String _
                        )

    m_strCountryList = RHS

End Property

Public Property Get CountryList() As String

    CountryList = m_strCountryList

End Property

Public Property Let Locked _
                        ( _
                        ByVal RHS As Boolean _
                        )

    m_blnLocked = RHS

End Property

Private Property Get Locked() As Boolean

    Locked = m_blnLocked

End Property

Public Property Get ShowAgain() As Boolean

    ShowAgain = m_blnShowAgain

End Property

Public Property Let ShowAgain _
                        ( _
                        ByVal RHS As Boolean _
                        )

    m_blnShowAgain = RHS

End Property

Private Sub Form_Initialize()
    
    Set m_objPhoneNumber = New PhoneNumber
    
End Sub

Private Sub Form_Load()
    
    On Error GoTo ErrorHandler
    
    LoadResources
    
    LoadCountryCodes
    
    With PhoneNumber
        lblCompletePhone.Caption = .Serialize
        
        On Error Resume Next
        
        cboCountryRegion.Text = .GetCountryDescription(CountryList)
        
        Err.Clear
        
        On Error GoTo ErrorHandler
        
        txtCityAreaCode.Text = .CityCode
        txtLocalNumber.Text = .LocalNumber
    End With
    
    chkShowAgain.Value = IIf(ShowAgain, vbChecked, vbUnchecked)
    
    fmePhoneDetails.Enabled = Not Locked
    
ExitHere:
    GoSub CleanUp
    Exit Sub
ErrorHandler:
    
CleanUp:
    ' After populating the Country/Region ComboBox and setting the current item
    ' we'll get rid of this huge string variable (6 to 7 Kb)
    CountryList = vbNullString
    Return
End Sub

Private Sub LoadResources()

    On Error GoTo ErrorHandler
    
    Me.Caption = LoadResString(ResStrCheckPhoneNumberDialogCaption)
    fmePhoneDetails.Caption = LoadResString(ResStrPhoneDetailsFrameCaption)
    lblCountryRegion.Caption = LoadResString(ResStrCountryRegionLabelCaption)
    lblCityAreaCode.Caption = LoadResString(ResStrCityAreaLabelCaption)
    lblLocalNumber.Caption = LoadResString(ResStrLocalNumberLabelCaption)
    chkShowAgain.Caption = LoadResString(ResStrShowAgainCheckBoxCaption)
    cmdOk.Caption = LoadResString(ResStrOKButtonCaption)
    cmdCancel.Caption = LoadResString(ResStrCancelButtonCaption)

ExitHere:
    Exit Sub
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    Resume Next
End Sub

Private Sub LoadCountryCodes()

    Const COUNTRY_NAME As Long = 0
    Const COUNTRY_CODE As Long = 1
    
    Dim v_vntCountries As Variant
    Dim v_vntIdx As Variant
    Dim v_vntCountry As Variant
    
    v_vntCountries = Split(Expression:=CountryList, Delimiter:="@", Compare:=vbTextCompare)
    
    For Each v_vntIdx In v_vntCountries
    
        v_vntCountry = Split(Expression:=v_vntIdx, Delimiter:="=", Compare:=vbTextCompare)
        
        With cboCountryRegion
            .AddItem v_vntCountry(COUNTRY_NAME)
            .ItemData(.NewIndex) = CLng(v_vntCountry(COUNTRY_CODE))
        End With
        
    Next v_vntIdx

End Sub

Private Sub Form_Terminate()

    Set m_objPhoneNumber = Nothing

End Sub

Private Sub txtCityAreaCode_Change()
    
    PhoneNumber.CityCode = txtCityAreaCode.Text
    lblCompletePhone.Caption = PhoneNumber.Serialize

End Sub

Private Sub txtCityAreaCode_GotFocus()
    
    With txtCityAreaCode
        .SelStart = 0
        .SelLength = Len(.Text)
    End With
    
End Sub

Private Sub txtCityAreaCode_KeyDown _
                        ( _
                        KeyCode As Integer, _
                        Shift As Integer _
                        )

    If KeyCode = vbKeyF2 Then
        With txtCityAreaCode
            .SelLength = 0
            .SelStart = Len(.Text)
        End With
    End If

End Sub

Private Sub txtLocalNumber_Change()
    
    PhoneNumber.LocalNumber = txtLocalNumber.Text
    lblCompletePhone.Caption = PhoneNumber.Serialize
    
End Sub

Private Sub txtLocalNumber_GotFocus()
    
    With txtLocalNumber
        .SelStart = 0
        .SelLength = Len(.Text)
    End With

End Sub

Private Sub txtLocalNumber_KeyDown _
                        ( _
                        KeyCode As Integer, _
                        Shift As Integer _
                        )
    
    If KeyCode = vbKeyF2 Then
        With txtLocalNumber
            .SelLength = 0
            .SelStart = Len(.Text)
        End With
    End If

End Sub
